var self = Titanium.UI.currentWindow;
var view = Titanium.UI.createView({
	//layout: 'horizontal',
	backgroundColor: '#ffffff',
	backgroundImage: '/images/wooden.png'
});
var lastIndex = 0;
var updateWin;
var busy = false;
var categoryTableView = Titanium.UI.createTableView();
var table = 'iqquestions';
var lang = L('language');
var question = '';
var answer = '';
var rowno = 0;
var unique=0;
var favoriteData=[];
var mylink = L('mylink');
// populate category array from database
// only called on first rendering of the tab, after that the array is filled


function getLastId(table) {
		var db = Titanium.Database.open(L('contentDB'));
		var dbrows = db.execute('select max(id) as max from ' + table + ' where lang = ?', lang);
		
		var max =dbrows.fieldByName('max');
	
		dbrows.close();
		db.close();
		
		return max; 
}

function getMaxId(lang) {
		var db = Titanium.Database.open(L('contentDB'));
		var dbrows = db.execute('select max(rowno) as max from iqquestions where lang = ? ', lang);
		
		var max =dbrows.fieldByName('max');
	
		dbrows.close();
		db.close();
		
		return max; 
}


function isFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	var dbrows = db.execute('select _id from favorite where _id = ? ', no);
	while (dbrows.isValidRow()) {
		var idno =dbrows.fieldByName('_id');
		
			dbrows.close();
			db.close();
			if (idno === null || idno === undefined)
				return false;
		
			return true;
	}
	dbrows.close();
	db.close();
	return false;
}

function addToFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	db.execute('insert or ignore into favorite select * from iqquestions where _id = ? ', no);
		
		//dbrows.close();
		db.close();
}



function removeFromFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	db.execute('delete from favorite where _id = ? ', no);
		
		//dbrows.close();
		db.close();
}


function generateTableRowFromFavorite() {
	var rowItem = [];
				var db = Titanium.Database.open(L('contentDB'));
				var dbrows = db.execute('select * from favorite' );
				var c=0;
				while (dbrows.isValidRow()) {
						var id = dbrows.fieldByName('rowno');
						var question = dbrows.fieldByName('question');
						var answer = dbrows.fieldByName('answer');
						var unique = dbrows.fieldByName('_id');
					    var row = Ti.UI.createTableViewRow({
					    	height:'auto',
					    	backgroundColor:'#ffffff',
					    	backgroundSelectedColor:'#eeee33',
					    	id: id,
				    		question: question,
				    		answer: answer,
				    		unique: unique
			    		}); 
					    var currentSize = Ti.App.Properties.getInt('fontSize');
			    		var titleLable = Ti.UI.createLabel({
							text: id + '. ' + question,
							color: '#334499',
							textAlign:'left',
							left:5,
							top:10,
							buttom:10,
							height:'auto',
							font:{fontWeight:'bold',fontSize:currentSize}
						});
			    		
			    		row.add(titleLable);
			    		rowItem[c] = row;
			    		dbrows.next();
			    		c++;
					}
				
				dbrows.close();
				db.close();
				favoriteTableView.setData(rowItem);
	
};




var verticalBar = Titanium.UI.createView({
	layout: 'vertical',
	width: 65,
	top: 0,
	left:0
});

var questionView = Titanium.UI.createView({
	left: 65,
	top: 20,
	right:9,
	//height: Titanium.Platform.displayCaps.platformHeight - 200,
	height: '80%',
	borderWidth: 2,
  	borderColor: '#808080',
  	backgroundColor: '#ffffff',
  	borderRadius: 8
});

var questionScrollView = Titanium.UI.createScrollView({
});


var favoriteTableView = Titanium.UI.createTableView({
	data:[]
});

favoriteTableView.addEventListener('click', function(e) {
	setQuestionScrollView(e.row.unique,e.row.question, e.row.answer, e.row.rowno );
	favoriteTableView.hide();
	//favoriteTableView.animate({zIndex:1});
	//questionView.remove(favoriteTableView);
	questionScrollView.show();
	//questionScrollView.animate({zIndex:10});
	//questionView.add(questionScrollView);
	
});


var questionLabel = Titanium.UI.createLabel({
	//text: question,
	color: '#334499',
	textAlign:'left',
	left:5,
	right:5,
	top:10,
	width: 'auto',
	height:'auto',
	font:{fontWeight:'bold',fontSize:20}
});

questionScrollView.add(questionLabel);
//questionPane.add(questionScrollView);

var fontsizeBtn = Titanium.UI.createButton({
	top: 10,
	width: 48,
	height: 48,
	backgroundImage: '/images/fontsize.png',
});

fontsizeBtn.addEventListener('click', function(e) {
	var currentSize = Ti.App.Properties.getInt('fontSize');
	if (currentSize > 36) {
		currentSize = 18;
	}
	else {
		currentSize = currentSize +4;
	}
	Ti.App.Properties.setInt('fontSize',currentSize);
	questionLabel.font = {fontSize:currentSize};
	
	
});


var buttonList = Titanium.UI.createButton({
	top: 20,
	width: 48,
	height: 48,
	backgroundImage:'/images/heart.png'
});

buttonList.addEventListener('click', function(e) {
	generateTableRowFromFavorite();
	
	favoriteTableView.show();
	//questionView.add(favoriteTableView);
	questionScrollView.hide();
	//questionView.remove(questionScrollView);
});


var buttonStart = Titanium.UI.createButton({
	top:30,
	width: 48,
	height: 48,
	backgroundImage: '/images/smile.png'
});

buttonStart.addEventListener('click', function(e) {
	favoriteTableView.hide();
	//questionView.remove(favoriteTableView);
	questionScrollView.show();
	//questionView.add(questionScrollView);
});


buttonStart.addEventListener('click', function (e) {
	getRandomJoke();
    //questionPane.open();
});

var answerBtn = Titanium.UI.createButton({
	bottom: 10,
	//left: 5,
	width: 48,
	height: 48,
	backgroundImage: '/images/unlock.png',
	answer: answer
});

var favBtn = Titanium.UI.createButton({
	bottom: 10,
	left: 10,
	width: 48,
	height: 48,
	backgroundImage: '/images/silverstar.png',
	backgroundSelectedImage: '/images/goldstar.png'
});

favBtn.addEventListener('click', function(e) {
	if (isFavorite(unique)) {
		removeFromFavorite(unique);
		favBtn.backgroundImage= '/images/silverstar.png';
		favBtn.backgroundSelectedImage= '/images/goldstar.png';
	}
	else {
		addToFavorite(unique);
		favBtn.backgroundImage= '/images/goldstar.png';
		favBtn.backgroundSelectedImage= '/images/silverstar.png';
	}
	
});

var btnNext =  Titanium.UI.createButton({
	bottom: 10,
	right: 10,
	width: 48,
	height: 48,
	backgroundImage: '/images/next.png'
});

btnNext.addEventListener('click', function(e) {
	getRandomJoke();
});

answerBtn.addEventListener('click', function (e) {
	Ti.UI.createAlertDialog({
    message: answerBtn.answer,
    ok: L('ok'),
    title: L('answer')
  }).show();
	//alert(answer);
});


var btnWhatsapp = Titanium.UI.createButton({
	top: 30,
	width: 50,
	height: 53,
	backgroundImage: '/images/whatsapp_small.png'
});


btnWhatsapp.addEventListener('click', function(e) {
	if (question !== '') {
	
		var intent = Ti.Android.createIntent({
		action: Ti.Android.ACTION_SEND,
		type: "text/plain",
		packageName: "com.whatsapp"
		});
		if (intent !== null) {
			intent.putExtra(Ti.Android.EXTRA_TEXT, question + "\n\n" + mylink);
			
			var chooser = Ti.Android.createIntentChooser(intent, "Share with");
			Ti.Android.currentActivity.startActivity(chooser);
		}
	}
	
});

var btnWechat = Titanium.UI.createButton({
	top: 30,
	width: 50,
	height: 50,
	backgroundImage: '/images/wechat.png'
});


btnWechat.addEventListener('click', function(e) {
	if (question !== '') {
	
		var intent = Ti.Android.createIntent({
		action: Ti.Android.ACTION_SEND,
		type: "text/plain",
		packageName: "com.tencent.mm"
		});
		if (intent !== null) {
			intent.putExtra(Ti.Android.EXTRA_TEXT, question + "\n\n" + mylink);
			
			var chooser = Ti.Android.createIntentChooser(intent, "Share with");
			Ti.Android.currentActivity.startActivity(chooser);
		}
	}
});


var btnFacebook = Titanium.UI.createButton({
	top: 30,
	width: 50,
	height: 50,
	backgroundImage: '/images/facebook_small.png'
});


btnFacebook.addEventListener('click', function(e) {
	if (question !== '') {
	
	var data = {
		    link : L('facebook_iq_link'),
	    	name : L('facebook_iq_name'),
			//message : "This is the message",
			//caption : L('facebook_caption'),
			caption: L('facebook_iq_name'),
			//picture : L('facebook_image'),
			description : question
	};
	
	 var fb = require('facebook');
	 fb.appid = L('fbappid');
	 fb.permissions = ['publish_stream'];	 
			//log in and accept permissions
			//fb.permissions = ['email'];
			//fb.authorize();
			//share dialog
				//fb.dialog("feed", data, function(e) {
			fb.dialog("feed", data, function(e) {
				if(e.success && e.result) {
					alert(L('facebook_po_msg') + e.result);
				} else {
				    if(e.error) {
				        alert(e.error);
				    } else {
				        alert(L('facebook_user_cancel'));
				    }
			    }
			});
	}
});




questionScrollView.add(favBtn);
questionScrollView.add(answerBtn);
questionScrollView.add(btnNext);



questionView.add(favoriteTableView);
questionView.add(questionScrollView);

function getRandomJoke() {
	var random = Math.floor((Math.random()* getMaxId(lang))+1);
	
	var db = Titanium.Database.open(L('contentDB'));
	var dbrows = db.execute('select _id, rowno, question, answer from iqquestions where rowno = ? and lang = ?', random, lang );
	
					if (dbrows.isValidRow()) {
						rowno = dbrows.fieldByName('rowno');
						question = dbrows.fieldByName('question');
						answer = dbrows.fieldByName('answer');
					    unique = dbrows.fieldByName('_id');
					    questionLabel.text = question;
					    answerBtn.answer = answer;
					    
					}
				
				dbrows.close();
				db.close();
				
				if (isFavorite(unique)) {
					favBtn.backgroundImage='/images/goldstar.png';
					favBtn.backgroundSelectedImage='/images/silverstar.png';
				}
				else { 
					favBtn.backgroundImage='/images/silverstar.png';
					favBtn.backgroundSelectedImage='/images/goldstar.png';
				}
};

function setQuestionScrollView(id1, question1, answer1,rowno1) {
	unique = id1;
	question = question1;
	answer = answer1;
	rowno = rowno1;
	questionLabel.text = question1;
	answerBtn.answer = answer1;
	if (isFavorite(unique)) {
		favBtn.backgroundImage='/images/goldstar.png';
		favBtn.backgroundSelectedImage='/images/silverstar.png';
		
	}
};

//generateTableRowFromDB();
// category view event listener
//categoryTableView.addEventListener('click', handleCategoryClick);
//view.add(categoryTableView);
//categoryTableView.fireEvent('click', {vid: 1});

verticalBar.add(fontsizeBtn);
verticalBar.add(buttonStart);
verticalBar.add(buttonList);
verticalBar.add(btnWhatsapp);
verticalBar.add(btnWechat);
verticalBar.add(btnFacebook);
view.add(verticalBar);


			var Admob = require('ti.admob');
			var mySmart =  L('admob_smart');
	//		var myPublisherId =  'a152dbf6c73efb1';
	
			var adv = Admob.createView({
			bottom: 0,
			adSizeType: 'SMART',
			publisherId: mySmart ,
			testing: false
			});
			view.add(adv);


view.add(questionView);
// add category table view to the window
Titanium.UI.currentWindow.add(view);